package com.jdc.jdcproject.controller;

import com.jdc.jdcproject.entity.Equipment;
import com.jdc.jdcproject.entity.FangpaishuiUnit;
import com.jdc.jdcproject.entity.VO.FangpaishuiUnitVo;
import com.jdc.jdcproject.service.EquipmentService;
import com.jdc.jdcproject.service.FangpaishuiUnitService;
import com.jdc.jdcproject.utils.Result;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/fangpaishuiUnitController")
public class FangpaishuiUnitController {
    @Autowired
    private FangpaishuiUnitService fangpaishuiUnitService;

    @Operation(summary = "查询所有机组")
    @GetMapping("findAllUnit")
    public Result findAllUnit() {
        List<FangpaishuiUnitVo> vos = fangpaishuiUnitService.findAllUnit();
        return Result.successResult().data("unitVos", vos);
    }
    @Operation(summary = "根据id查询机组信息")
    @GetMapping("findUnitById/{id}")
    public Result findEquipmentById(@PathVariable int id) {
        FangpaishuiUnitVo vo = fangpaishuiUnitService.findUnitById(id);
        return Result.successResult().data("vo", vo);
    }
    @Operation(summary = "修改机组信息")
    @PostMapping("updateUnit")
    public Result updateUnit(@RequestBody FangpaishuiUnit fangpaishuiUnit) {
        boolean updateflag = fangpaishuiUnitService.updateById(fangpaishuiUnit);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "删除机组信息")
    @DeleteMapping("deleteUnit/{id}")
    public Result deleteUnit(@PathVariable int id) {
        boolean updateflag = fangpaishuiUnitService.removeById(id);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "新增机组信息")
    @PostMapping("addUnit")
    public Result addUnit(@RequestBody FangpaishuiUnit fangpaishuiUnit) {
        System.out.println(fangpaishuiUnit);

        boolean updateflag = fangpaishuiUnitService.save(fangpaishuiUnit);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }
}
