package com.jdc.jdcproject.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jdc.jdcproject.entity.Renyuanjiegou;
import com.jdc.jdcproject.service.IRenyuanjiegouService;
import com.jdc.jdcproject.utils.RenYuanUtil;
import com.jdc.jdcproject.utils.Result;
import io.swagger.v3.oas.annotations.Hidden;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author haoyanlu
 * @since 2025-04-26
 */
@RestController
@RequestMapping("/renyuanjiegou")
public class RenyuanjiegouController {

    @Autowired
    private IRenyuanjiegouService renyuanjiegouService;

    //查询全部
    @Operation(summary = "查询所有人员")
    @GetMapping("findAll")
    public Result findAll() {

        //调用service实现查询
        List<Renyuanjiegou> renyuanjiegouList = renyuanjiegouService.list();

        Map<String, Renyuanjiegou> stringRenyuanjiegouMap = RenYuanUtil.renyuanSum(renyuanjiegouList);

        //将所有厂区及部门数据整合方便前端增加数据时回显
        Map<String,List<String>> changqubumenMap = new HashMap<>();
        for (Renyuanjiegou renyuan : renyuanjiegouList) {
            if (changqubumenMap.containsKey(renyuan.getChangQu())) {
                changqubumenMap.get(renyuan.getChangQu()).add(renyuan.getBuMen());
            } else {
                // 如果没有该 ChangQu 的记录，则直接加入
                List<String> bumenList = new ArrayList<>();
                bumenList.add(renyuan.getBuMen());
                changqubumenMap.put(renyuan.getChangQu(), bumenList);
            }
        }
        return Result.successResult().data("bumenChangqujilu", changqubumenMap).data("renyuanjiegou", renyuanjiegouList).data("renyuanSum",stringRenyuanjiegouMap);
    }

    /**todo
     * 目前只存在按月分查询人员
     * 后续可新增其他条件查询条件
     */
    //按月份查询人员
    @Operation(summary = "按月份进行查询")
    @PostMapping("findforMoth")
    public Result findforMoth(@RequestBody(required = false) Renyuanjiegou renyuanjiegou) {
        QueryWrapper<Renyuanjiegou> queryWrapper = new QueryWrapper<>();
        if (!StringUtils.isEmpty(renyuanjiegou.getStrMonth())) {
           queryWrapper.like("strMonth", renyuanjiegou.getStrMonth());
        }

        List<Renyuanjiegou> renyuanjiegouList = renyuanjiegouService.list(queryWrapper);



        //数据整合
        Map<String, Renyuanjiegou> stringRenyuanjiegouMap = RenYuanUtil.renyuanSum(renyuanjiegouList);

        return Result.successResult().data("renyuanjiegou", renyuanjiegouList).data("renyuanSum",stringRenyuanjiegouMap);
    }

    //新增数据
    @Operation(summary = "新增数据")
    @PostMapping("addRy")
    public Result addTeacher(@RequestBody Renyuanjiegou renyuanjiegou) {
        boolean saveFlag = renyuanjiegouService.save(renyuanjiegou);
        if (saveFlag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }
}
